/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the UpdateCveRecordRejectionRequestCnaContainer type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &UpdateCveRecordRejectionRequestCnaContainer{}

// UpdateCveRecordRejectionRequestCnaContainer struct for UpdateCveRecordRejectionRequestCnaContainer
type UpdateCveRecordRejectionRequestCnaContainer struct {
	ProviderMetadata *GetCveRecordResponseContainersCnaProviderMetadata `json:"providerMetadata,omitempty"`
	RejectedReasons []CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner `json:"rejectedReasons"`
	ReplacedBy []string `json:"replacedBy,omitempty"`
}

// NewUpdateCveRecordRejectionRequestCnaContainer instantiates a new UpdateCveRecordRejectionRequestCnaContainer object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewUpdateCveRecordRejectionRequestCnaContainer(rejectedReasons []CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) *UpdateCveRecordRejectionRequestCnaContainer {
	this := UpdateCveRecordRejectionRequestCnaContainer{}
	this.RejectedReasons = rejectedReasons
	return &this
}

// NewUpdateCveRecordRejectionRequestCnaContainerWithDefaults instantiates a new UpdateCveRecordRejectionRequestCnaContainer object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewUpdateCveRecordRejectionRequestCnaContainerWithDefaults() *UpdateCveRecordRejectionRequestCnaContainer {
	this := UpdateCveRecordRejectionRequestCnaContainer{}
	return &this
}

// GetProviderMetadata returns the ProviderMetadata field value if set, zero value otherwise.
func (o *UpdateCveRecordRejectionRequestCnaContainer) GetProviderMetadata() GetCveRecordResponseContainersCnaProviderMetadata {
	if o == nil || IsNil(o.ProviderMetadata) {
		var ret GetCveRecordResponseContainersCnaProviderMetadata
		return ret
	}
	return *o.ProviderMetadata
}

// GetProviderMetadataOk returns a tuple with the ProviderMetadata field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UpdateCveRecordRejectionRequestCnaContainer) GetProviderMetadataOk() (*GetCveRecordResponseContainersCnaProviderMetadata, bool) {
	if o == nil || IsNil(o.ProviderMetadata) {
		return nil, false
	}
	return o.ProviderMetadata, true
}

// HasProviderMetadata returns a boolean if a field has been set.
func (o *UpdateCveRecordRejectionRequestCnaContainer) HasProviderMetadata() bool {
	if o != nil && !IsNil(o.ProviderMetadata) {
		return true
	}

	return false
}

// SetProviderMetadata gets a reference to the given GetCveRecordResponseContainersCnaProviderMetadata and assigns it to the ProviderMetadata field.
func (o *UpdateCveRecordRejectionRequestCnaContainer) SetProviderMetadata(v GetCveRecordResponseContainersCnaProviderMetadata) {
	o.ProviderMetadata = &v
}

// GetRejectedReasons returns the RejectedReasons field value
func (o *UpdateCveRecordRejectionRequestCnaContainer) GetRejectedReasons() []CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner {
	if o == nil {
		var ret []CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner
		return ret
	}

	return o.RejectedReasons
}

// GetRejectedReasonsOk returns a tuple with the RejectedReasons field value
// and a boolean to check if the value has been set.
func (o *UpdateCveRecordRejectionRequestCnaContainer) GetRejectedReasonsOk() ([]CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner, bool) {
	if o == nil {
		return nil, false
	}
	return o.RejectedReasons, true
}

// SetRejectedReasons sets field value
func (o *UpdateCveRecordRejectionRequestCnaContainer) SetRejectedReasons(v []CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) {
	o.RejectedReasons = v
}

// GetReplacedBy returns the ReplacedBy field value if set, zero value otherwise.
func (o *UpdateCveRecordRejectionRequestCnaContainer) GetReplacedBy() []string {
	if o == nil || IsNil(o.ReplacedBy) {
		var ret []string
		return ret
	}
	return o.ReplacedBy
}

// GetReplacedByOk returns a tuple with the ReplacedBy field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UpdateCveRecordRejectionRequestCnaContainer) GetReplacedByOk() ([]string, bool) {
	if o == nil || IsNil(o.ReplacedBy) {
		return nil, false
	}
	return o.ReplacedBy, true
}

// HasReplacedBy returns a boolean if a field has been set.
func (o *UpdateCveRecordRejectionRequestCnaContainer) HasReplacedBy() bool {
	if o != nil && !IsNil(o.ReplacedBy) {
		return true
	}

	return false
}

// SetReplacedBy gets a reference to the given []string and assigns it to the ReplacedBy field.
func (o *UpdateCveRecordRejectionRequestCnaContainer) SetReplacedBy(v []string) {
	o.ReplacedBy = v
}

func (o UpdateCveRecordRejectionRequestCnaContainer) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o UpdateCveRecordRejectionRequestCnaContainer) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ProviderMetadata) {
		toSerialize["providerMetadata"] = o.ProviderMetadata
	}
	toSerialize["rejectedReasons"] = o.RejectedReasons
	if !IsNil(o.ReplacedBy) {
		toSerialize["replacedBy"] = o.ReplacedBy
	}
	return toSerialize, nil
}

type NullableUpdateCveRecordRejectionRequestCnaContainer struct {
	value *UpdateCveRecordRejectionRequestCnaContainer
	isSet bool
}

func (v NullableUpdateCveRecordRejectionRequestCnaContainer) Get() *UpdateCveRecordRejectionRequestCnaContainer {
	return v.value
}

func (v *NullableUpdateCveRecordRejectionRequestCnaContainer) Set(val *UpdateCveRecordRejectionRequestCnaContainer) {
	v.value = val
	v.isSet = true
}

func (v NullableUpdateCveRecordRejectionRequestCnaContainer) IsSet() bool {
	return v.isSet
}

func (v *NullableUpdateCveRecordRejectionRequestCnaContainer) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUpdateCveRecordRejectionRequestCnaContainer(val *UpdateCveRecordRejectionRequestCnaContainer) *NullableUpdateCveRecordRejectionRequestCnaContainer {
	return &NullableUpdateCveRecordRejectionRequestCnaContainer{value: val, isSet: true}
}

func (v NullableUpdateCveRecordRejectionRequestCnaContainer) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUpdateCveRecordRejectionRequestCnaContainer) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


